
function [ref, meas, pred, nr_agents, mean_d_gp, var_d_gp] ...
    = make_gp_measurements(test_index, nr_agents, field, stage, param, make_new, plot_new)

if make_new
    
    %% 1. refernce data Ѵ.
    random_position     = 1;
    uniform_position    = 0;
    
    % 1.  ġ
    if random_position
        ref.pos    = [ field.xmin + (field.xmax - field.xmin)*rand(nr_agents, 1) ...
            field.ymin + (field.ymax - field.ymin)*rand(nr_agents, 1) ];
        ref.data   = zeros(nr_agents, 1);
    end
    
    % 2. Uniformϰ ġ
    if uniform_position
        field_w  = 3;
        field_h  = nr_agents / field_w;
        xs       = linspace(field.xmin, field.xmax, field_w+2);
        ys       = linspace(field.ymin, field.ymax, field_h+2);
        xs       = xs(2:field_w+1);
        ys       = ys(2:field_h+1);
        [fx, fy] = meshgrid(xs, ys);
        ref.pos  = [fx(:) fy(:)];
        ref.data = zeros(nr_agents, 1);
    end
    
    for ni = 1:nr_agents
        %  agent ش ġ measurement Ѵ.
        x_curr          = ref.pos(ni, 1);
        y_curr          = ref.pos(ni, 2);
        
        ref.data(ni)    = interp2(field.xgrid, ...
            (field.ygrid), field.zdata, ...
            x_curr, y_curr );
    end
    
    % 2. measurement data Ѵ. (refͿ  ´.)
    meas.data           = ref.data + sqrt(param.sigma2_obs_y)*randn(size(ref.data));
    for ni = 1:nr_agents
        while 1
            meas.pos(ni, :)     = ref.pos(ni, :) + sqrt(param.sigma2_obs_x)*randn(1, 2);
            if field.xmin <= meas.pos(ni, 1) && meas.pos(ni, 1) <= field.xmax ...
                    && field.ymin <= meas.pos(ni, 2) && meas.pos(ni, 2) <= field.ymax
                break;
            end
        end
    end
    
    % 3. prediction points Ѵ.
    % pred.pos = [reshape(field.xgrid, [], 1), reshape(flipud(field.ygrid), [], 1)];
    pred.pos = [reshape(field.xgrid, [], 1), reshape((field.ygrid), [], 1)];
    
    % 4. Ѵ.
    save(['data/gp_measurement_' num2str(test_index) '.mat'] ...
        , 'ref', 'meas', 'pred', 'nr_agents' );
    
else
    % ο ͸   ҷ´.
    load(['data/gp_measurement_' num2str(test_index) '.mat'] );
    
end

%% measurement  ƴ Ȯϱ ؼ ׸ ׷.
if plot_new
    %% 
    figure('Position', [100 100 400 700]);
    subplot(211);
    
    % 1.  Field ׸.
    pcolor(stage.xgrid, stage.ygrid, field.zdata);
    % set(gca,'YDir','normal');  % ߿! <= Matrix Graph y  ݴ̴.
    colorbar; caxis([field.zmin field.zmax]); hold on;
    shading interp;lighting phong;
    
    % 2. measurement ġ, ش sensor value plotѴ. .
    for ei = 1:nr_agents
        hold on;
        
        % multi-agent consensus   agent neighbor ǥϴ routine
        if isfield(param, 'radiusKernel')
            for ej = ei+1:nr_agents
                pos_i = ref.pos(ei,:);
                pos_j = ref.pos(ej,:);
                dist_ij = norm(pos_i-pos_j);
                if dist_ij < param.radiusKernel
                    plot( [pos_i(1) pos_j(1)] , [pos_i(2) pos_j(2)] ,'w-', 'LineWidth', 2);
                end
            end
        end
        
        h_ref = plot(ref.pos(ei, 1), ref.pos(ei, 2), 'o', 'LineWidth',2,...
            'MarkerEdgeColor','g',...
            'MarkerFaceColor','w',...
            'MarkerSize',10, 'LineWidth', 3);
        h_meas = plot(meas.pos(ei, 1), meas.pos(ei, 2), 'o', 'LineWidth',2,...
            'MarkerEdgeColor','k',...
            'MarkerSize',10, 'LineWidth', 3);
        str = sprintf('   [%d] %.3f', ei, meas.data(ei));
        text(meas.pos(ei, 1), meas.pos(ei, 2), str);
        hold off;
    end
    legend([h_ref h_meas], 'Real position', 'Measurement position', 4); 
    title('Gaussain Process Realization and Estimates');
    
    subplot(212);
    [zhatxstar sigma2xstar] = sjGP(pred.pos, meas.pos, meas.data, param);
    mean_d_gp         = reshape(zhatxstar, field.yres,  field.xres );
    var_d_gp          = reshape(sigma2xstar, field.yres, field.xres);
    pcolor(stage.xgrid, stage.ygrid, mean_d_gp);
    % set(gca,'YDir','normal');  % ߿! <= Matrix Graph y  ݴ̴.
    colorbar; caxis([field.zmin field.zmax]); hold on;
    shading interp;lighting phong; 
    for ei = 1:nr_agents
        hold on;
        plot(meas.pos(ei, 1), meas.pos(ei, 2), 'o', 'LineWidth',2,...
            'MarkerEdgeColor','k',...
            'MarkerSize',4, 'LineWidth', 1);
        str = sprintf('   [%d] %.3f', ei, meas.data(ei));
        text(meas.pos(ei, 1), meas.pos(ei, 2), str);
        hold off;
    end
    title('Gaussain Process Prediction');
else
    [zhatxstar sigma2xstar] = sjGP(pred.pos, meas.pos, meas.data, param);
    mean_d_gp         = reshape(zhatxstar, field.yres,  field.xres );
    var_d_gp          = reshape(sigma2xstar, field.yres, field.xres);
end

