function K = sjGP_kernel(X1, X2, option)
%
% X1: ʹ col ִ.
% X2: ʹ col ִ.
%
% ⿡ sigma2w ԵǾ ʴ!! 
%
% <SE kernel  1>
% option_gp.useSE_K    = 1;
% option_gp.sigma2f    = 1;
% option_gp.sigma2w    = 1E-3;
% option_gp.sigma2x    = 5E-1;
% option_gp.Grad = 0; <== ̺ Ѵ.   ϴ scalar
% 
% <D kernel  2>
% option_gp.useD_K     = 1;
% option_gp.sigma2f    = 1;
% option_gp.sigma2w    = 1E-3;
% option_gp.r          = 0.5;
% option_gp.Grad = 0;
%
% 
%

if ~isfield(option, 'Grad')
    option.Grad = 0;
end
if ~isfield(option, 'useSE_K')
    option.useSE_K = 0;
end
if ~isfield(option, 'useD_K')
    option.useD_K = 0;
end

len_X1  = size(X1, 1);
len_X2  = size(X2, 1);
K       = zeros(len_X1, len_X2);

for i = 1:len_X1
    for j  = 1:len_X2
        
        if option.Grad
            % X1 ̺ gradient Ѵ. (  տ  K   ̴.)
            % ̺ Ϲ ϳ X1 X2 Ѵ. (:  ġ, len_X1 = len_X2 = 1)
            if option.useSE_K
                K = se_kernel(X1(i,:), X2(j,:), option)*-(X1(i,:)-X2(j,:))/option.sigma2x;
            elseif option.useD_K
                diff  = X1(i,:) - X2(j,:);
                dist  = norm(diff);
                sig2f = option.sigma2f;
                r     = option.r;
                if dist == 0
                    K   = zeros(size(diff));
                elseif dist > r
                    K   = zeros(size(diff));
                else
                    K   = sig2f*pi*(dist/r-1)*sin(pi*dist/r)*diff/dist/r;                    
                end
                K = K*1E3;
            end
        else
            % kernel  Ѵ. 
            if option.useSE_K
                K_data = se_kernel(X1(i,:), X2(j,:), option);
            elseif option.useD_K
                K_data = distribute_kernel(X1(i,:), X2(j,:), option);
            end 
            
            if isequal(X1(i,:), X2(j,:))
                %  ġ sigma2w Ѵ. 
                K(i, j) = K_data + sqrt(option.sigma2w); 
            else 
                K(i, j) = K_data; 
            end
            
        end
    end
end

end

%%
function output = se_kernel(x1, x2, option)
    % output = option.sigma2f*exp(-norm(x1-x2)^2/option.sigma2x/2);
    
    x_diff = x1 - x2;
    x_diff = x_diff';
    Lambda = (option.sigma2x*eye(size(x1, 2)));
    alpha_sq = option.sigma2f;
    output = alpha_sq*exp(-0.5*x_diff'/Lambda*x_diff);
end

%%
function output = distribute_kernel(x1, x2, option)
    output = option.sigma2f*Lambda(norm(x1-x2)/option.r);
end

function output_lambda = Lambda(h)
    if h <= 1 
        output_lambda = (1-h)*cos(pi*h) + 1/pi*sin(pi*h);
    else 
        output_lambda = 0;
    end
end
