function sjGP_plot(gp_data_fields, gp_field, option)
%
% < >
%
% %% 1. plot  field Ѵ. 
% gp_data_fields{1}       = field.zdata;
% gp_data_fields{2}       = mean_ref_gp;
% gp_data_fields{3}       = mean_qds_gp;
% gp_data_fields{4}       = mean_d_gp; 
% 
% option_plot = [];
% option_plot.title{1}    = '1. Gaussian Process Realization';
% option_plot.title{2}    = '2. Gaussian Process using Reference Data';
% option_plot.title{3}    = '3. Gaussian Process using Noisy Data';
% option_plot.title{4}    = '4. Gaussian Process using D-GP Data';
% 
% %% 2. agent ġ Ѵ. 
% option_plot.plot_agent_pos  = 1;
% option_plot.plot_agent_data = 0;
% option_plot.meas{1}     = [];
% option_plot.meas{2}     = ref;
% option_plot.meas{2}.data= meas.data; % <== ref data meas . 
% option_plot.meas{3}     = meas;
% option_plot.meas{4}     = dgp;
% option_plot.nr_plots    = 4;
% 
% %% ̰ ߰ϸ plot line ߰Ѵ. 
% option_plot.r = option_dgp.r;
% 
% %% Variance (̰ ߰ϸ var   plotѴ.)
% option_plot.var{1}     = [];
% option_plot.var{2}     = var_ref_gp;
% option_plot.var{3}     = var_qds_gp;
% option_plot.var{4}     = var_d_gp;
% 
% %% plotѴ. 
% sjGP_plot(gp_data_fields, field, option_plot);
%
%
if nargin == 2
    option = [];
end
nr_fields = length(gp_data_fields);

% ⺻ Figure  
if ~isfield(option, 'nr_plots')
    option.nr_plots = nr_fields;
end

% ⺻ Figure Name 
if ~isfield(option, 'fig_name')
    option.fig_name = 'Gaussian process regression results';
end

% ⺻ Figure Postion 
if ~isfield(option, 'position')
    if ~isfield(option, 'var')
        option.position(1) = 100;
        option.position(2) = 100;
        option.position(3) = 200+300*option.nr_plots;
        option.position(4) = 300;
    else
        option.position(1) = 100;
        option.position(2) = 100;
        option.position(3) = 200+300*option.nr_plots;
        option.position(4) = 600;
    end
end 

% Plot  agent ġ ǥ  
if ~isfield(option, 'plot_agent_pos')
    option.plot_agent_pos = 0;
end

% Plot  agent  ǥ   
if ~isfield(option, 'plot_agent_data')
    option.plot_agent_data = 0;
end 

% Title ָ ׳ ڷ Ѵ.
if ~isfield(option, 'title')
    for ti = 1:option.nr_plots
        option.title{ti} = ['plot' num2str(ti) ];
    end
end

nr_plots         = option.nr_plots;       %  plot 
start_end_margin = 0.01;    % ۰  margin
rel_margin       = 0.01;    % plot  margin
xstart_width     = zeros(nr_plots, 2);
start_pos        = start_end_margin;
average_width    = (1-2*start_end_margin)/nr_plots - 2*rel_margin;
for xi = 1:nr_plots
    start_pos = start_pos + rel_margin;
    xstart_width(xi, 1) = start_pos;
    xstart_width(xi, 2) = average_width;
    start_pos = start_pos + average_width+ rel_margin;
end

%% 
fig_sj_gp_plot = figure('Position'...
    , [option.position(1) option.position(2) ...
    option.position(3) option.position(4)] ...
    , 'name', option.fig_name );


if ~isempty(gp_data_fields{1})
    c_range = minmax(reshape(gp_data_fields{1}, 1, []));
elseif option.nr_plots >= 2
    c_range = minmax(reshape(gp_data_fields{2}, 1, []));
end 

if isfield(option, 'var')
    if ~isempty(option.var{1})
        c_range2 = minmax(reshape(option.var{1}, 1, []));
    elseif option.nr_plots >= 2
        c_range2 = minmax(reshape(option.var{2}, 1, []));
    end
end

for plot_i = 1:option.nr_plots
    
    if ~isfield(option, 'var')
       %% mean plotѴ. 
        
        axes('Parent',fig_sj_gp_plot,'Position',[xstart_width(plot_i,1) 0.05 average_width 0.85]);
        title(option.title{plot_i});
        if isempty(gp_data_fields{plot_i}), continue; end;
        
        pcolor(linspace(gp_field.xmin, gp_field.xmax, gp_field.xres) ...
            , linspace(gp_field.ymax, gp_field.ymin, gp_field.yres), gp_data_fields{plot_i} );
        hold on;
        set(gca,'YDir','normal'); colorbar; caxis([c_range(1) c_range(2)]);
        shading interp; lighting phong;
        title(option.title{plot_i});
        
        plot_k = option.nr_plots;
        nr_agents = length(option.meas{plot_k}.pos);
        if isfield(option, 'r')
            for ai = 1:nr_agents
                for aj = 1:nr_agents
                    pos_i = option.meas{plot_k}.pos(ai, :);
                    pos_j = option.meas{plot_k}.pos(aj, :);
                    dist_ij = norm(pos_i-pos_j);
                    if dist_ij < option.r
                        plot([pos_i(1) pos_j(1)], [pos_i(2) pos_j(2)], 'b-');
                    end
                end
            end
        end
        
        % agent ġ x plotѴ.
        if option.plot_agent_pos
            if isempty(option.meas{plot_i}), continue; end;
            h1 = plot(option.meas{plot_i}.pos(:,1), option.meas{plot_i}.pos(:,2) ...
                , 'mx','LineWidth', 4 , 'MarkerSize', 10);
        end
        
        % agent measurement  plotѴ.
        if option.plot_agent_data
            if isempty(option.meas{plot_i}), continue; end;
            for pi = 1:length(option.meas{plot_i}.data)
                str = ['  ' '[' num2str(pi) ']' num2str(option.meas{plot_i}.data(pi), '%.2f') ];
                h2 = text(option.meas{plot_i}.pos(pi,1), option.meas{plot_i}.pos(pi,2), str, 'Color', 'b');
            end;
        else
            if isempty(option.meas{plot_i}), continue; end;
            for pi = 1:length(option.meas{plot_i}.data)
                str = ['  ' '[' num2str(pi) ']' ];
                h2 = text(option.meas{plot_i}.pos(pi,1), option.meas{plot_i}.pos(pi,2), str, 'Color', 'b');
            end;
        end
        
        hold off;
        
    else
       %% mean var  plotѴ. 
       
       %%
        axes('Parent',fig_sj_gp_plot,'Position',[xstart_width(plot_i,1) 0.55 average_width 0.40]);
        title([option.title{plot_i} ' Mean' ] );
        if isempty(gp_data_fields{plot_i}), continue; end;
        
        pcolor(linspace(gp_field.xmin, gp_field.xmax, gp_field.xres) ...
            , linspace(gp_field.ymax, gp_field.ymin, gp_field.yres), gp_data_fields{plot_i} );
        hold on;
        set(gca,'YDir','normal'); colorbar; caxis([c_range(1) c_range(2)]);
        shading interp; lighting phong;
        title([option.title{plot_i} ' Mean' ] );
        
        plot_k = option.nr_plots;
        nr_agents = length(option.meas{plot_k}.pos);
        if isfield(option, 'r')
            for ai = 1:nr_agents
                for aj = 1:nr_agents
                    pos_i = option.meas{plot_k}.pos(ai, :);
                    pos_j = option.meas{plot_k}.pos(aj, :);
                    dist_ij = norm(pos_i-pos_j);
                    if dist_ij < option.r
                        plot([pos_i(1) pos_j(1)], [pos_i(2) pos_j(2)], 'b-');
                    end
                end
            end
        end
        
        % agent ġ x plotѴ.
        if option.plot_agent_pos
            if isempty(option.meas{plot_i}), continue; end;
            h1 = plot(option.meas{plot_i}.pos(:,1), option.meas{plot_i}.pos(:,2) ...
                , 'mx','LineWidth', 4 , 'MarkerSize', 10);
        end
        
        % agent measurement  plotѴ.
        if option.plot_agent_data
            if isempty(option.meas{plot_i}), continue; end;
            for pi = 1:length(option.meas{plot_i}.data)
                str = ['  ' '[' num2str(pi) ']' num2str(option.meas{plot_i}.data(pi), '%.2f') ];
                h2 = text(option.meas{plot_i}.pos(pi,1), option.meas{plot_i}.pos(pi,2), str, 'Color', 'b');
            end;
        else
            if isempty(option.meas{plot_i}), continue; end;
            for pi = 1:length(option.meas{plot_i}.data)
                str = ['  ' '[' num2str(pi) ']' ];
                h2 = text(option.meas{plot_i}.pos(pi,1), option.meas{plot_i}.pos(pi,2), str, 'Color', 'b');
            end;
        end
        
        hold off;
        
       %% variance 
       
        axes('Parent',fig_sj_gp_plot,'Position',[xstart_width(plot_i,1) 0.05 average_width 0.40]);
        title([option.title{plot_i} ' Variance' ] );
        if isempty(option.var{plot_i}), continue; end;
        
        pcolor(linspace(gp_field.xmin, gp_field.xmax, gp_field.xres) ...
            , linspace(gp_field.ymax, gp_field.ymin, gp_field.yres), option.var{plot_i} );
        hold on;
        set(gca,'YDir','normal'); colorbar; caxis([c_range2(1) c_range2(2)]);
        shading interp; lighting phong;
        title([option.title{plot_i} ' Variance' ] );
        
        plot_k = option.nr_plots;
        nr_agents = length(option.meas{plot_k}.pos);
        if isfield(option, 'r') 
            for ai = 1:nr_agents
                for aj = 1:nr_agents
                    pos_i = option.meas{plot_k}.pos(ai, :);
                    pos_j = option.meas{plot_k}.pos(aj, :);
                    dist_ij = norm(pos_i-pos_j);
                    if dist_ij < option.r
                        plot([pos_i(1) pos_j(1)], [pos_i(2) pos_j(2)], 'b-');
                    end
                end
            end
        end
        
        % agent ġ x plotѴ.
        if option.plot_agent_pos
            if isempty(option.meas{plot_i}), continue; end;
            h1 = plot(option.meas{plot_i}.pos(:,1), option.meas{plot_i}.pos(:,2) ...
                , 'mx','LineWidth', 4 , 'MarkerSize', 10);
        end
        
        % agent measurement  plotѴ.
        if option.plot_agent_data
            if isempty(option.meas{plot_i}), continue; end;
            for pi = 1:length(option.meas{plot_i}.data)
                str = ['  ' '[' num2str(pi) ']' num2str(option.meas{plot_i}.data(pi), '%.2f') ];
                h2 = text(option.meas{plot_i}.pos(pi,1), option.meas{plot_i}.pos(pi,2), str, 'Color', 'b');
            end;
        else
            if isempty(option.meas{plot_i}), continue; end;
            for pi = 1:length(option.meas{plot_i}.data)
                str = ['  ' '[' num2str(pi) ']' ];
                h2 = text(option.meas{plot_i}.pos(pi,1), option.meas{plot_i}.pos(pi,2), str, 'Color', 'b');
            end;
        end
        
        hold off;
        
    end
    
end










