function [spectral_idx, spectral_center] ...
    = sjSpectralCluster(meas, option)
%
% data:  ʹ  column  ִٰ Ѵ. 
% option.nr_classes:   ŭ . 
%

if ~isfield(option, 'iter')
    option.iter = 100;
end

rng(5);
pos     = meas.pos;
data    = meas.data;
nr_data = size(pos, 1);

A = zeros(nr_data, nr_data);
for ai = 1:nr_data
    for aj = 1:nr_data
        if ai == aj, continue; end;
        pos_i     = pos(ai, :);
        pos_j     = pos(aj, :);
        pos_diff_ij   = norm(pos_i - pos_j);
        data_i    = data(ai, :);
        data_j    = data(aj, :);
        data_diff_ij   = norm(data_i - data_j);
        A(ai, aj) = exp(-(data_diff_ij^2)/option.sigma2d ...
            -(pos_diff_ij^2)/option.sigma2x );
    end 
end
D = diag(sum(A));
L = D^(-0.5)*A*D^(-0.5);
[V, D]  = eig(L); 
% V eigenvector ִ. top k e.vector Ѵ.
top_k_eigvectors = V(:, 1:option.nr_classes);

% row  normalizeϰ ̰ Y ִ´. 
Y       = zeros(nr_data, option.nr_classes);
for ri = 1:option.nr_classes
    row_curr        = top_k_eigvectors(:, ri);
    norm_row_curr   = norm(row_curr);
    Y(:, ri)        = top_k_eigvectors(:, ri)/norm_row_curr;
end
%% ̷ ؼ  Y row ϳ ͷ  kmeans Ѵ. 
kmeans_input    = Y;
kmeans_nr_class = option.nr_classes;          % K-means ̿ؼ   cluster 
opts = statset(); % 'Display', 'final'
nr_kmeans_repeat = option.iter;
[spectral_idx, spectral_center] = kmeans(kmeans_input, kmeans_nr_class,...
    'Distance',     'sqEuclidean',...        %'sqEuclidean', 'cityblock', 'correlation', 'Hamming', ...
    'Replicates',   nr_kmeans_repeat,...   % Number of times to repeat the clustering
    'emptyaction',  'drop',... 
    'Options', opts );

%% 




